/*
 *
 *  Configuration specific compiler declarations.
 *
 *  Copyright (c) 1999 Richard J.M. Close
 *
 *  Can be freely distributed and used under the terms of the GNU GPL.
 */

#ifndef LT_CONFIG_H

#define LT_CONFIG_H 1

// Country code.
// The default country (the continent of North America) is 0x19.
// UK is 14, Czech reb. = 40, Italy = 8, see countries.h.
#define COUNTRY_CODE 14

// Version number.
#define LTMODEM_VERSION "0.9.9"

// Set to 1 to turn on debugging.
#define LT_DEBUG 1

// Set to 1 to turn on detailed debugging of tone detection stuff.
#define LT_DEBUG_TONES 0

// Set to 1 to turn on detailed debugging of port I/O stuff.
#define LT_DEBUG_IO 0

// Set to try out hard interrupt code.
#define TRY_INTERRUPTS 0
// Device used to detect IRQ from user space.
#define IRQ_DEV "/dev/usirq9" 

// Set to enable answer tone detection after dialing.
#define WAIT_FOR_ANSWER 1

// Set to enable dial tone detection before dialing.
#define WAIT_FOR_DIALTONE 1

// Set to hang up after dialling with -d option.
// Only useful for debugging.
#define HANGUP_AFTER_DIAL 0  

// Set to enable some hacks which Pavel needed to
// get his Toshiba modem working.
#define PAVEL_FIX 1

#endif



