/*
 * Higher level Modem control routines.
 *
 * Copyright 1999 Pavel Machek and R.J.M. Close, distribute under GPL
 */

#ifndef	LT_CONTROL_H

#define	LT_CONTROL_H 1
 
#include <stdio.h>
#include "time_utils.h"
#include "portIO.h"
#include "task.h"
#include "dp_call.h"
#include "init.h"
#include "lapm.h"

// Local variables.
unsigned int dp_answer_on_timer;
unsigned int dp_answer_off_timer;

// Ouch, is it real command for going offhook? It looks like it is used only in some tests!
void go_offhook(void);

bool dp_offhook_cmd(void);

void dp_onhook_cmd(void);

void dp_hdlc_mode(void);
void dp_async_8bit_mode(void);
void dp_async_user_mode(void);

bool dp_carrier_loss(void);
unsigned char dp_retrain(void);
void dp_modem_rate(void);

// Fill in, if needed.
unsigned short dp_test_cmd (unsigned int arg1, unsigned char* arg2);

void dp_56k_speaker_cmd (void);

void Modem_Resume(void);

void dp_download_V8bis(void);
void dp_download_dsp (unsigned char* data, unsigned count);
void dp_download_fax(void);

void dp_retrain_cmd(void);
void dp_fast_retrain_cmd(void);

void dp_originate_cmd (void);
void dp_answer_cmd(void);
bool dp_line_connect(void);

void dp_update_diagnostics (void);

// Move this dummy definition later.
void dp_update_rate(void);
void dp_update_modem_options(void);
void dp_v8_originate_msg(void);
void dp_over_current_alert (void);

void dp_get_line_rate (void);
bool dp_stored_number(unsigned char* dial_str);
bool dp_test_dialstring(unsigned char* dial_str);

void dp_disable_workaround(void);

void dp_transmit_level (unsigned int level);

// Dummy routine.
void dp_rate_change_cmd(unsigned int rate);
void dp_auto_rate (void);
void dp_sleep_mode(unsigned char arg1);

void dp_enable_ring_int(void);

void dp_modem_idle_cmd (void);

void dp_v34_workaround(void);

bool dp_dial_connect_success(void);
bool dp_init_modem_connection(void);

void dp_disable_33600 (void);

#endif
