/*
 * PCM related stuff?
 *
 *	Copyright (c) 2000 Richard J.M. Close
 *
 * Can be distributed under GPL
 */

#include "dp_vpcm.h"

// Load necessary DSP programs.
// The Lucent 568 driver does some extra stuff, mostly for mars3 chips.
// Although this code is as per 535 driver, I have used the DSP code from
// the 568 driver as this is the only one for which I have both binary and
// a decent disassembly.
// Translated from 568 version.
void dp_download_vpcm(void)
{
  unsigned int dspRamLoc;

  if (dp_vpcm_state == 3){

	dp_modem_idle_cmd();

    if (x_dsp_mars3 == 0) {     //goto 19df5;

	  printf("dp_download_vpcm: clearing DSP RAM...");
	  // Clear DSP RAM from 0x1400 to 0x27FF
	  for (dspRamLoc = 0x1400; dspRamLoc < 0x2800; dspRamLoc++)
		dp_write_dsp_ram(dspRamLoc, 0);

	  printf(" downloading wDspVpcm_Core, ");
	  dp_download_dsp(wDspVpcm_Core, 0x803);    
	  printf(" wDspVpcm_Mi2RT, ");
	  dp_download_dsp(wDspVpcm_Mi2RT, 0x3e);
	  printf(" wDspVpcm_ComSec, ");
	  dp_download_dsp(wDspVpcm_ComSec, 0x161);
	  printf(" wDspVpcm_V90Wk1.");
	  dp_download_dsp(wDspVpcm_V90Wk1, 0x23e); 
	}
	else {
	  dp_write_dsp_ram(0x27f0, 0);

	  printf("dp_download_vpcm: Error mars3 not yet supported.\n");
	  //dp_download_dsp(wDspm3Vpcm_dPop, 6);
	  //dp_download_dsp(wDspm3Vpcm_Mi2RT, 0x3e); 
	  //dp_download_dsp(wDspm3Vpcm_ComSec, 0x161);
	  //dp_download_dsp(wDspm3Vpcm_V90Wk1, 0x23e);
	  //dp_download_dsp(wDspm3Vpcm_Core2, 0xe3);    
	}
  }
  //19e53:	
  if (x_dsp_mars3 == 0) {
	//19e92:
	printf(" downloading wDspVpcm_Mi2Wk, etc. ...");
	dp_download_dsp(wDspVpcm_Mi2Wk, 0x1ec);   // 568 has size = 0x1ec.
	dp_download_dsp(wDspVpcm_Ph31, 0x36e);    // 568 has size = 0x36e
	dp_download_dsp(wDspVpcm_TrnTb, 0x13);    
	dp_download_dsp(wDspVpcm_Diltbl, 0x80);
	printf(" done.\n");
  }
  else {
	printf("dp_download_vpcm: Error mars3 not yet supported.\n");
	//dp_download_dsp(wDspm3Vpcm_Mi2Wk, 0x1fc);
	//dp_download_dsp(wDspm3Vpcm_Ph31, 0x37f);  
	//dp_download_dsp(wDspm3Vpcm_TrnTb, 0x13);    
	//dp_download_dsp(wDspm3Vpcm_Diltbl, 0x80);
  }
}

// Taken from 568 dis. 535 is the same.
void dp_vpcm_update_connect_status(void)
{

  x_line_rate_tx = (0xffff & dp_read_dsp_ram(0x833)) + 4;

  if (S(0x6d) == 100)
    x_line_rate = 29;
  else
    x_line_rate = VpcmRate + 33;

  dp_update_diagnostics();
}

// Taken from 535 dis.
// The 568 version has a lot more stuff in.
// One of the possible paths does however match the code
// below, but the others use different values in DSP
// according the chipset type.
void dp_vpcm_startup_cmd (unsigned int arg1)
{
  printf("dp_vpcm_startup_cmd(%d).\n", arg1);

  V34Mode = 0;
  dp_write_dsp_ram(0x1FF2, 5);
  dp_write_dsp_ram(0x1FF3, 0x36E6);
  dp_write_dsp_ram(0x1FF4, 0x3909);
  dp_write_dsp_ram(0x0F20, 0xE490);
  dp_write_dsp_ram(0x0C, 0x0F);

  dp_regwrite(0x34, arg1);

  dp_modem_command(0x1B, 0xD0, 0);
}

/*
_dp_vpcm_dial_connect_success@0:
   3d8a8:	6a 3a          	pushl  $0x3a
   3d8aa:	e8 41 6a ff ff 	call   _dp_read_dsp_ram@4
   3d8af:	a8 08          	testb  $0x8,%al
   3d8b1:	74 5e          	je     0x3d911 <_dp_vpcm_dial_connect_success@0+0x69>
   3d8b3:	6a 0c          	pushl  $0xc
   3d8b5:	68 f8 1f 00 00 	pushl  $0x1ff8
   3d8ba:	e8 e1 69 ff ff 	call   _dp_write_dsp_ram@8
   3d8bf:	66 a1 46 0e 06 00 	movw   _VpcmRate,%ax
   3d8c5:	66 a3 4c 0e 06 00 	movw   %ax,_VpcmMaxRate
   3d8cb:	a1 e0 ff 05 00 	movl   0x5ffe0 <_cpcpt_value+0xb40>,%eax
   3d8d0:	99             	cltd   
   3d8d1:	2b c2          	subl   %edx,%eax
   3d8d3:	d1 f8          	sarl   %eax
   3d8d5:	66 3d 20 00    	cmpw   $0x20,%ax
   3d8d9:	66 a3 3c 0e 06 00 	movw   %ax,_Min_dist
   3d8df:	73 0a          	jae    0x3d8eb <_dp_vpcm_dial_connect_success@0+0x43>

   3d8e1:	66 b8 20 00    	movw   $0x20,%ax
   3d8e5:	66 a3 3c 0e 06 00 	movw   %ax,_Min_dist

   3d8eb:	50             	pushl  %eax
   3d8ec:	68 b9 20 00 00 	pushl  $0x20b9
   3d8f1:	e8 aa 69 ff ff 	call   _dp_write_dsp_ram@8

   3d8f6:	6a 00          	pushl  $0x0
   3d8f8:	68 57 02 00 00 	pushl  $0x257
   3d8fd:	e8 9e 69 ff ff 	call   _dp_write_dsp_ram@8

   3d902:	6a 00          	pushl  $0x0
   3d904:	68 44 21 00 00 	pushl  $0x2144
   3d909:	e8 92 69 ff ff 	call   _dp_write_dsp_ram@8

   3d90e:	b0 01          	movb   $0x1,%al
   3d910:	c3             	ret   
 
   3d911:	32 c0          	xorb   %al,%al
   3d913:	c3             	ret    

568 version:
0001a068 <dp_vpcm_dial_connect_success>:
   1a068:	6a 3a          	pushl  $0x3a
   1a06a:	e8 fc ff ff ff 	call   dp_read_dsp_ram
   1a06f:	83 c4 04       	addl   $0x4,%esp
   1a072:	a8 08          	testb  $0x8,%al
   1a074:	0f 84 8a 00 00 	je     1a104 <dp_vpcm_dial_connect_success+0x9c>
   1a079:	00 
   1a07a:	80 3d 00 00 00 	cmpb   $0x0,0x0
   1a07f:	00 00 
			1a07c: R_386_32	x_chip_version
   1a081:	75 0d          	jne    1a090 <dp_vpcm_dial_connect_success+0x28>
   1a083:	80 3d 00 00 00 	cmpb   $0x0,0x0
   1a088:	00 00 
			1a085: R_386_32	x_dsp_mars
   1a08a:	74 04          	je     1a090 <dp_vpcm_dial_connect_success+0x28>

   1a08c:	6a 0d          	pushl  $0xd
   1a08e:	eb 02          	jmp    1a092 <dp_vpcm_dial_connect_success+0x2a>

   1a090:	6a 0c          	pushl  $0xc
   1a092:	68 f8 1f 00 00 	pushl  $0x1ff8
   1a097:	e8 fc ff ff ff 	call   dp_write_dsp_ram

   1a09c:	83 c4 08       	addl   $0x8,%esp
   1a09f:	66 a1 00 00 00 	movw   VpcmRate,%ax
   1a0a4:	00 
   1a0a5:	66 a3 00 00 00 	movw   %ax,VpcmMaxRate
   1a0aa:	00 
   1a0ab:	a1 40 0b 00 00 	movl   (cpcpt_value + 0xb40),%eax
   1a0b0:	c1 e8 1f       	shrl   $0x1f,%eax
   1a0b3:	03 05 40 0b 00 	addl   (cpcpt_value + 0xb40),%eax
   1a0b8:	00 
   1a0b9:	c1 f8 01       	sarl   $0x1,%eax
   1a0bc:	66 a3 00 00 00 	movw   %ax,Min_dist
   1a0c1:	00 
   1a0c2:	66 83 f8 1f    	cmpw   $0x1f,%ax
   1a0c6:	77 09          	ja     1a0d1 <dp_vpcm_dial_connect_success+0x69>

   1a0c8:	66 c7 05 00 00 	movw   $0x20,Min_dist
   1a0cd:	00 00 20 00 
   1a0d1:	0f b7 05 00 00 	movzwl Min_dist,%eax
   1a0d6:	00 00 

   1a0d8:	50             	pushl  %eax
   1a0d9:	68 b9 20 00 00 	pushl  $0x20b9
   1a0de:	e8 fc ff ff ff 	call   dp_write_dsp_ram

   1a0e3:	6a 00          	pushl  $0x0
   1a0e5:	68 57 02 00 00 	pushl  $0x257
   1a0ea:	e8 fc ff ff ff 	call   dp_write_dsp_ram

   1a0ef:	6a 00          	pushl  $0x0
   1a0f1:	68 44 21 00 00 	pushl  $0x2144
   1a0f6:	e8 fc ff ff ff 	call   dp_write_dsp_ram

   1a0fb:	b8 01 00 00 00 	movl   $0x1,%eax
   1a100:	83 c4 18       	addl   $0x18,%esp
   1a103:	c3             	ret
    
   1a104:	31 c0          	xorl   %eax,%eax
   1a106:	c3             	ret    

*/

// Exactly the same as the 568 version.
void dp_vpcm_retrain_jump(void)
{
  init_ll_para();
  dp_write_dsp_ram(0xf20, 0xcef2);
  dp_modem_command(0x1b, 0xce, 0xc0);
}

// 568 version.
void dp_vpcm_to_v34_retrain(void)
{
  if (x_dsp_mars3 == 4){
	// Chipset specific.
	dp_write_dsp_ram(0x1bf3, 0);
	// Sort this out when we add mars3 support!
	//dp_write_dsp_array(0x1ad7, V34taps, 0x15);
  }
  dp_lapm_error_check_init();
  V34Mode = 1;

  dp_write_dsp_ram(0x823, 0x3ff);

  if (S_dial_line_rate == 0)
	dp_write_dsp_ram(0x80d, 0x9fff);

  //1a198:
  dp_write_dsp_ram(0x1ff0, 0);
  dp_transmit_level(10);

  if (x_dsp_mars3 != 4) goto loc_1a1d1;

  if ((S(0xd2) & 2) == 0) goto loc_1a1d1;

  dp_transmit_level(13);

loc_1a1d1:
  if (x_dsp_mars3 == 0) //goto loc_1a1e0;
	dp_write_dsp_ram(0xf20, 0x42f8);
  else
	dp_write_dsp_ram(0xf20, 0x4228);

  dp_modem_command(0x1b, 0xce, 0xc0);

  dp_write_dsp_ram(0xc, 0);

  // xstatus[0x24] and xstatus[0x25] are accessed as a word.
  *(unsigned short*)(x_status + 0x24) = *(unsigned short*)(x_status + 0x24) + 1;
}

//568 version.
void dp_vpcm_v34_init(void)
{
  V34Mode = 1;

  if (DpIdleFillChar == 0x7e)
	dp_hdlc_mode();
  else
	dp_async_user_mode();

  dp_regread(0xb0);
  dp_bV34WkState = 0;

  if (vpcm_retrain_flag == 1)
	dp_state = 50;
  else if (vpcm_retrain_flag == 2)
	dp_state = 11;

  //loc_1a26e:	
  dp_vpcm_state = 1;
  dp_timer = x_current_time();
  dp_timer1 = x_current_time();

  dp_regread(0xb0);
  dp_bGoodAuto = 0;
  dp_count = 0;
}

//568 version.
void dp_vpcm_retrain_cmd_v34(void)
{
  dp_vpcm_to_v34_retrain();
  vpcm_timer = x_current_time();
  x_set_current_time(&dp_long_timer);
  dp_vpcm_v34_init();
  dp_vpcm_flag = 0;
  //return true;
}

// 568 version.
void dp_vpcm_retrain_cmd_vpcm(void)
{
  dp_vpcm_retrain_jump();
  dp_vpcm_options_init();
  vpcm_timer = x_current_time();
  dp_timer = x_current_time();

  // xstatus[0x24] and xstatus[0x25] are accessed as a word.
  *(unsigned short*)(x_status + 0x24) = *(unsigned short*)(x_status + 0x24) + 1;

  dp_vpcm_state = 10;
  DSP_ER_flag = 1;
  //return true;
}

// 568 version.
void dp_vpcm_fast_rate_change(void)
{
  dp_timer = x_current_time();
  dp_modem_command(0x1b, 0xd0, 0);
  dp_vpcm_state = 23;
  // xstatus[0x24] and xstatus[0x25] are accessed as a word.
  *(unsigned short*)(x_status + 0x24) = *(unsigned short*)(x_status + 0x24) + 1;
}

// 568 version.
bool dp_vpcm_retrain_cmd(unsigned char arg1)
{

  if (dp_vpcm_state <= 1) return false;
  if (dp_vpcm_state == 16) goto loc_1a380;

  if (arg1 != 0)
    x_send_mail (0x25, 3, 0, 0);

  return true;

loc_1a380:
  if (arg1 == 1) goto loc_1a450;
  if (arg1 > 1) goto loc_1a397;
  if (arg1 == 0) goto loc_1a3a5;
  return true;

loc_1a397:
  if (arg1 == 2) goto loc_1a470;
  return true;

loc_1a3a5:
  vpcm_retrain_flag = 1;
  if (x_modem_ec != 0) goto loc_1a3c0;

  dp_vpcm_retrain_cmd_v34();
  return true;

loc_1a3c0:
  if (VpcmRate <= 18) goto loc_1a3e0;

  dp_vpcm_retrain_cmd_vpcm();
  VpcmMaxRate = 18;
  return true;

loc_1a3e0:
  if (VpcmRate <= 14) goto loc_1a400;

  dp_vpcm_retrain_cmd_vpcm();
  VpcmMaxRate = 14;
  return true;

loc_1a400:
  if (VpcmRate <= 8) goto loc_1a416;

  dp_vpcm_retrain_cmd_vpcm();
  VpcmMaxRate = 8;
  return true;

loc_1a416:
  if (VpcmRate <= 2) goto loc_1a430;

  dp_vpcm_retrain_cmd_vpcm();
  VpcmMaxRate = 2;

loc_1a430:
  dp_write_dsp_ram(0x825,0x2400);
  dp_vpcm_retrain_cmd_v34();
  return true;


loc_1a450:
  vpcm_retrain_flag = 2;
  if (S(0x83) == 0)
	dp_vpcm_retrain_cmd_v34();
  else
	dp_vpcm_retrain_cmd_vpcm();
  return true;

loc_1a470:
  vpcm_retrain_flag = 2;
  if (S(0x83) != 1)
	VpcmMaxRate = S(0x83) - 1;

  dp_vpcm_fast_rate_change();

  //1a494
  return true;
}

// Initialises V PCM stuff, returns true if initialised OK(?)
bool dp_vpcm_init (void)
{
  if ((S(0x38) == 8) ||
	  (S(0x83) == 0) ||
	  (cell_active) ||
	  (dp_version == 0x39)) {
	// Abort initialisation.
	printf("dp_vpcm_init: aborting initialisation!\n");
	return false; 
  }

  //printf("dp_vpcm_init: starting initialisation.\n");
  vpcm_retrain_flag  = false;
  x_set_current_time(&dp_long_timer);
  vpcm_timer = x_current_time();
  dp_vpcm_state = 3;   // State = initialising?

  // Download VPCM code to DSP.
  dp_download_vpcm();
  dp_update_modem_options();

  if (x_modem_originate)
	dp_vpcm_startup_cmd(1);
  else
	dp_vpcm_startup_cmd(0);

  // Initialise what?
  init_ll_para();

  printf("dp_vpcm_init: initialisation completed OK.\n");
  return true;
}

void dp_vpcm_idle(void)
{
  S(0x6b) = 0;
  if (dp_vpcm_state != 0) {
	x_modem_state = 1;
	dp_run_rom();
  }
  dp_vpcm_state = 0;
}

void dp_vpcm_options_init (void)
{ 
  unsigned short ax;

  ax = S(0x83);
  if (ax != 1) goto loc_3657E;
  VpcmMaxRate = 19;

  dp_write_dsp_ram(0x1FF8, 0x14);
  goto loc_3658B;

loc_3657E:
  ax--;
  VpcmMaxRate = ax;
  dp_write_dsp_ram(0x1FF8, 0x1c);

loc_3658B:
  dp_write_dsp_ram(0x1FF0, 1);

  if (country_code == COUNTRY_JAPAN)
    dp_transmit_level(16);
  else
    dp_transmit_level(14);

  //loc_365B0:
  dp_write_dsp_ram(0x823, 0x100);
  dp_write_dsp_ram(0x27FC, cpcpt_value[0xb38]);
  dp_write_dsp_ram(0x1ff7, 0);
  dp_write_dsp_ram(0x1fef, 0xffff);

}

bool dp_vpcm_print_dsp_sptr(void)
{ 
  unsigned int eax, esi, edi;

  if (dp_vpcm_state == 16) return true;

  edi = dp_read_dsp_ram(0x80);

  if (dp_byte_f != 1) return false;

  //loc_36616:
  esi = dp_read_dsp_ram(0xcf);
  eax = vpcm_sptr;
  if ((eax != edi) && (vpcm_rptr == esi)) return true;

  //loc_36636:
  prev_vpcm_sptr = eax;
  vpcm_timer = x_current_time();
  vpcm_sptr = edi;
  vpcm_rptr = esi;

  //loc_36655: 
  return true;
} 

bool vpcm_retrain_detect(void)
{

  if (dp_read_dsp_ram(0x2144) == 1){

	dp_write_dsp_ram(0x2144, 0);

	*(unsigned short*)(x_status + 0x26) = *(unsigned short*)(x_status + 0x26) + 1;
	dp_timer = x_current_time();
	dp_vpcm_state = 23;
	vpcm_retrain_flag = true;
  }
  else {
	//loc_36699:
	if (dp_read_dsp_ram(0x257) != 1) return false;

	dp_write_dsp_ram(0x257, 0);

	*(unsigned short*)(x_status + 0x26) = *(unsigned short*)(x_status + 0x26) + 1;
	dp_vpcm_state = 27;
	x_set_current_time(&dp_long_timer);
	dp_vpcm_retrain_jump();
	vpcm_retrain_flag = true;
	vpcm_timer = x_current_time();
	dp_timer = x_current_time();
  }
  //loc_366EF:
  return true;
}


// Monster function, very important for making a connection.
// Convert to 568 version at 1a880:
void dp_vpcm_background(void)
{
  unsigned int eax, ebx, ecx, esi;

  // var_1		 = byte	ptr -1

  if (dp_vpcm_print_dsp_sptr() == false) goto loc_36886; // 1a994:

  if (dp_vpcm_state > 30) goto loc_37002;  //1b715

  switch(dp_vpcm_state) {
  case 0: case 1: case 2: //1b715:	
	break;

  case 3: // 1a8a3:
	esi = dp_read_dsp_ram(0x1FF1) & 3; // ebx in 568 stuff. 
	// Debug shows esi is always 0! :(
    printf(" VPCM(DSP RAM: %d) ", esi);

	if (dp_read_dsp_ram(0x828) == 0) goto loc_36816; //1a8ca
	if (esi == 2) goto loc_36816;
	if (esi != 1) goto loc_36864;

    printf(" VPCM(init) ");
	dp_vpcm_options_init();
	dp_disable_33600();

	dp_vpcm_state = 30;
	S(0x6b) = 1;
    goto loc_36864;

loc_36816:
    printf(" VPCM(1) ");
	dp_write_dsp_ram(0x0F20, 0x42F8);
	ebx = 0;
	dp_write_dsp_ram(0x0c, 0);

	dp_async_user_mode();
	dp_state = 13;         // Ready for connection init?

	dp_vpcm_state = 0;
	dp_timer = x_current_time();
	dp_timer1 = x_current_time();

	dp_regread(0xB0);

loc_36864:
	ecx = x_elapsed_long_time(&dp_long_timer);
	printf(" VPCM(2) elt = %d ", ecx);
	if (ecx < (unsigned int)(S_connect_completion_timeout * 10)) break;  //loc_37002

    printf(" VPCM(3) ");
loc_36886:  // 1a994:
	// Abandon connection attempt.
	dp_state = 33;
	x_dial_residual = 9;
	x_status[0x28] = 3;
	break;
	/*
// dp_vpcm_state == 3
   1a8a3:	68 f1 1f 00 00 	pushl  $0x1ff1
   1a8a8:	e8 fc ff ff ff 	call   dp_read_dsp_ram
   1a8ad:	89 c3          	movl   %eax,%ebx
   1a8af:	83 e3 03       	andl   $0x3,%ebx
   1a8b2:	68 28 08 00 00 	pushl  $0x828
   1a8b7:	e8 fc ff ff ff 	call   dp_read_dsp_ram
   1a8bc:	83 c4 08       	addl   $0x8,%esp
   1a8bf:	66 85 c0       	testw  %ax,%ax
   1a8c2:	74 06          	je     1a8ca <dp_vpcm_background+0x4a>

   1a8c4:	66 83 fb 02    	cmpw   $0x2,%bx
   1a8c8:	75 76          	jne    1a940 <dp_vpcm_background+0xc0>
-->
   1a8ca:	80 3d 00 00 00 	cmpb   $0x0,x_dsp_mars3
   1a8cf:	00 00 
   1a8d1:	74 0d          	je     1a8e0 <dp_vpcm_background+0x60>

   1a8d3:	68 28 42 00 00 	pushl  $0x4228
   1a8d8:	eb 0b          	jmp    1a8e5 <dp_vpcm_background+0x65>

--> Not mars 3
   1a8e0:	68 f8 42 00 00 	pushl  $0x42f8
-->
   1a8e5:	68 20 0f 00 00 	pushl  $0xf20
   1a8ea:	e8 fc ff ff ff 	call   dp_write_dsp_ram
   1a8ef:	83 c4 08       	addl   $0x8,%esp
   1a8f2:	6a 00          	pushl  $0x0
   1a8f4:	6a 0c          	pushl  $0xc
   1a8f6:	e8 fc ff ff ff 	call   dp_write_dsp_ram
   1a8fb:	e8 fc ff ff ff 	call   dp_async_user_mode
   1a900:	c7 05 00 00 00 	movl   $0xd,dp_state
   1a905:	00 0d 00 00 00 
   1a90a:	c7 05 00 00 00 	movl   $0x0,dp_vpcm_state
   1a914:	e8 fc ff ff ff 	call   x_current_time
   1a919:	66 a3 00 00 00 	movw   %ax,dp_timer
   1a91f:	e8 fc ff ff ff 	call   x_current_time
   1a924:	66 a3 00 00 00 	movw   %ax,dp_timer1
   1a92a:	68 b0 00 00 00 	pushl  $0xb0
   1a92f:	e8 fc ff ff ff 	call   dp_regread
   1a934:	83 c4 0c       	addl   $0xc,%esp
   1a937:	eb 36          	jmp    1a96f <dp_vpcm_background+0xef>

-->
   1a940:	66 83 fb 01    	cmpw   $0x1,%bx
   1a944:	75 29          	jne    1a96f <dp_vpcm_background+0xef>

   1a946:	e8 01 fc ff ff 	call   dp_vpcm_options_init
   1a94b:	e8 fc ff ff ff 	call   dp_disable_33600
   1a950:	c7 05 00 00 00 	movl   $0x1e,dp_vpcm_state
   1a95a:	c6 05 6b 00 00 	movb   $0x1,S(0x6b)
   1a95f:	00 01 
   1a961:	c6 05 00 00 00 	movb   $0x1,dp_vpcm_flag
   1a966:	00 01 
   1a968:	c6 05 00 00 00 	movb   $0x0,dp_hybrid_downloaded
   1a96d:	00 00 
-->
   1a96f:	ff 35 00 00 00 	pushl  dp_long_timer
   1a975:	e8 fc ff ff ff 	call   x_elapsed_long_time
   1a97a:	0f b7 d0       	movzwl %ax,%edx
   1a97d:	0f b6 05 07 00 	movzbl S(0x7),%eax
   1a982:	00 00 
   1a984:	8d 04 80       	leal   (%eax,%eax,4),%eax  * 5
   1a987:	01 c0          	addl   %eax,%eax           * 2 = * 10
   1a989:	83 c4 04       	addl   $0x4,%esp
   1a98c:	39 c2          	cmpl   %eax,%edx
   1a98e:	0f 8c 81 0d 00 	jl     1b715 <dp_vpcm_background+0xe95>
   1a993:	00 
   1a994:	c7 05 00 00 00 	movl   $0x21,dp_state     // dp_state = 33;
   1a99e:	c7 05 00 00 00 	movl   $0x9,x_dial_residual
   1a9a8:	c6 05 28 00 00 	movb   $0x3,x_status[0x28]
   1a9ad:	00 03 
   1a9af:	e9 61 0d 00 00 	jmp    1b715 <dp_vpcm_background+0xe95>
	*/
  case 4: // loc_37002
	break;

  case 5: //loc_37007

  case 6: //loc_3707C
  case 7: // loc_370C7
  case 8: //loc_37111
  case 9: //loc_37184
  case 10: //loc_36FE1
  case 11: //loc_37002
	break;
  case 12: //loc_36CB1
  case 13: //loc_36D0E
  case 14: //loc_36D65
  case 15: //loc_36DD5

  case 16: //loc_36A4F
	dp_vpcm_decoder();
	if (vpcm_retrain_detect() == true) break;

	if (dp_lapm_error_check() != 1) goto loc_36A7D;
	dp_count = 1;
    dp_vpcm_retrain_cmd(0);
    break;

loc_36A7D:


	break;

  case 17: //loc_3725B

  case 18: //loc_36922
	dp_vpcm_decoder();
	ebx = 0;
	eax = dp_read_dsp_ram(0x4c);
	x_status[0x10] = eax;
	if (VpcmMinDist < eax)
	  dp_count++;
	else
	  //loc_36947:				 ; CODE	XREF: dp_vpcm_background_0+199j
	  if (dp_count != 0) dp_count++;

	//loc_36955:
	if (x_elapsed_time(dp_timer) < 400) goto loc_369BC;

	if (S_auto_rate != 1) goto loc_36983;
	dp_vpcm_state = 20;
	dp_count = 1;
	goto loc_369BC;

loc_36983:
	ecx = x_elapsed_long_time(&dp_long_timer);
	eax = S_connect_completion_timeout * 10;
	if (ecx < eax) goto loc_369BC;
	// else timed out !
	dp_state = 33;
	x_dial_residual = 9;
	x_status[0x28] = 3;

loc_369BC:	
    if (dp_count <= 12) break;
	dp_vpcm_state = 16;
	x_modem_state = 6;
	vpcm_timer = x_current_time();
	dp_timer = x_current_time();
	dp_timer1 = x_current_time();

	x_status[1] = 5;
	dp_vpcm_update_connect_status();
	*(unsigned short*)(x_status + 2) = x_line_rate_tx;
	*(unsigned short*)(x_status + 4) = x_line_rate;

	dp_update_diagnostics();
	x_send_mail(0x17, 3, 0, 0);

    if ((S_speaker_enable = 1) || (S_speaker_enable = 3))
      x_output(7);
    //same as loc_36FA4:
    dp_count = 0;
    good_ff56_count = 0;
    dp_lapm_error_check_init();
    break;

  case 19: //loc_37002
	break;
  case 20: //loc_36B30
  case 21: //loc_36B8A
  case 22: //loc_37002
	break;
  case 23: //loc_36E82

  case 24: case 25: //loc_37002
	break;

  case 26: //loc_36F18
  case 27: //loc_36FE1
  case 28: //loc_37002
	break;

  case 29: //loc_37231
  case 30: //loc_368A6

	if (vpcm_sptr != 0xD090) goto loc_368FD;     //!! 568 uses 0xd07f

	eax = 0xffff & dp_read_dsp_ram(134);
	eax = eax -4;
	if (eax == 0) goto loc_368CE;
	eax = eax - 2;
	if (eax != 0) goto loc_368DD;

	dp_transmit_level(10);

loc_368CE:
	dp_write_dsp_ram(0x825, 0x2400);

loc_368DD:
	esi = 0x802;
	dp_read_dsp_ram(0x802);
	eax = eax & 0xEFFF;

	dp_write_dsp_ram(0x802, eax);

loc_368FD:
	eax = x_elapsed_time(vpcm_timer);
	if (eax < 5000) break;

	dp_vpcm_state = 20;
	break;

  // end of switch. loc_37002
  }

 loc_37002:  //1b715
  return;
}
