/*
 * Header file for main initialisation functions.
 *
 * Copyright 1999 R.J.M. Close, distribute under GPL
 */

#ifndef	LT_INITIALISATION_H

#define	LT_INITIALISATION_H

#include <time.h>
#include <unistd.h>

extern unsigned int dp_readram_failcnt;
int rom_checksum;

// Main initialisation routine which is called by the driver entry code. 
unsigned char MimicInit(void);

void big_init(void);

void modem_reset(void);

// Empty for now.
void v8bis_power_up_init(void);
void x_set_hardware_options(void);

unsigned char UART_init(void);
void UART_reset(void);

void x_init_modem_options(void);
void ll_init_modem_variables (void);

// Used in dp_task.
void dp_init_variables(void);
void dp_deinit_modem(void);
int dp_init_modem(void);

// What does this do?
void init_1027(unsigned int arg);

// UART initialisation.
void io_init_task(void);

// AT initialisation.
void at_init_variables(void);
void at_init_diagnostics(void);

// Country initialisation.
void x_init_international (void);
void x_init_international_default (void);
void ll_init_vendor (void);

void ll_init_uk(void);
void ll_init_na (void);
void ll_init_czech (void);

// V80 init.
void io_sync_power_up_init(void);

#endif

