/*
 *
 *	Stuff that does lapm (whatever that is!).
 *
 *	Copyright (c) 1999 Richard J.M. Close
 *
 *	Can be freely distributed and used under the terms of the GNU GPL.
 */

#ifndef LT_LAPM_H

#define LT_LAPM_H 1

#include "modem_globals.h"
#include "portIO.h"
#include "mnp.h"

// Don't know exactly how big these should be.
unsigned char lapm_transmit_frame[0x1000];
unsigned char lapm_receive_frame[0x1000];
unsigned char lapm_control_frame[0x1000];
unsigned char lapm_ui_frame[0x1000];
unsigned char lapm_receive_queue[0x1000];

// Local lapm vars.
unsigned int lapm_state;
unsigned short lapm_errors;
unsigned int good_ff56_count;

bool lapm_local_busy, lapm_remote_busy;
bool lapm_reject_sent;

unsigned int lapm_counter;
unsigned int lapm_frames;

unsigned char lapm_rx_iframe, lapm_frame_on_queue;
unsigned char lapm_v42b_err, lapm_iframe_on_queue;
unsigned char lapm_rx_dte_char;

unsigned char* lapm_iframe_ptr,* lapm_data_ptr;
unsigned char* lapm_odp_ptr,* lapm_odp_rptr;

unsigned char lapm_vs, lapm_va, lapm_vr, lapm_ns;
unsigned char lapm_vs, lapm_vrb, lapm_vsb, lapm_k;

unsigned char lapm_data_dlci, lapm_dsvd_dlci;
unsigned char lapm_n401, lapm_retransmit;

unsigned short lapm_t401;

// Should be global?
unsigned char dp_bV34WkState;
unsigned char dp_bFallForward;
unsigned char dp_bGoodAuto;

unsigned int dp_timer1;
unsigned int io_timer;

// lapm routines.
void lapm_init(void);

bool dp_lapm_error_check(void);
void dp_lapm_error_check_init (void);
void dp_lapm_auto_rate(void);

void lapm_init_variables(void);
void lapm_reset_timer(void);
bool lapm_timer_expired(int how_long);

#endif
