/*
 *
 *	Stuff that does mnp (whatever that is!).
 *
 *	Copyright (c) 1999 Richard J.M. Close
 *
 *	Can be freely distributed and used under the terms of the GNU GPL.
 */

#include "mnp.h"

void mnp_init_variables(void)
{
  unsigned short cl;

  lapm_init_variables();

  mnp_max_info_octects = _S[0x79] + (_S[0x80] * 256);

  cl = _S[0x39] & 1;
  cl--;
  mnp_vs = 0;
  cl = (~cl + 1);
  //sbb cl cl ? does this clear cl ?
  mnp_ns = 0;
  cl++;
  mnp_vr = 0;
  mnp_vsa = 0;

  mnp_vr = 0;
  mnp_vsa = 0;
  mnp_nsa = 0;
  mnp_vra = 0;
  mnp_nra = 0;
  mnp_rk = 0;
  mnp_nk = 0;
  mnp_sk = 0;

  mnp_framing_mode = 3;
  mnp_k = 8;
  mnp_data_opt_flag = 1;
  mnp_stream_opt_flag = 1;
  mnp_fixed_field_opt_flag = 1;
  mnp_data_compression = cl;
  mnp_attention_type = 3;
  mnp_disconnect_code = 0;
  mnp_user_disconnect_code = 0;
  mnp_retransmit = 0;
  mnp_first_lt_flag = 1;
  mnp_last_ack = 0;
  mnp_seq_recover_flag = 1;
  mnp_negotiated_mode = 2;
  mnp_rx_data_opt_flag = 0;
  mnp_rx_stream_opt_flag = 0;
  mnp_rx_fixed_field_opt_flag = 0;
  mnp_rx_data_compression = 0;
  mnp_rx_disconnect_code = 0;
  mnp_rx_user_disconnect_code = 0;
  mnp_state = 0;
}

// Called by io_periodic_task if io_state = 0xE.
unsigned int mnp_background(void)
{
  unsigned int eax, ebx;
  unsigned char al;

  eax = mnp_state;

  //push	 ebx
  eax--;
  //push	 esi
  if (eax > 9) return 1;

  switch (eax) {
  // jmp	 ds:off_3F85F[eax*4] ; switch jump

  case 0:
    //loc_3F3B6:
	// mnp_state is currently 1.
    mnp_build_lr_frame();
    mnp_tx_octet_frame();
    lapm_reset_timer();
    mnp_state = 2;
    return 1;

  case 1:  //loc_3F3D4:
	// mnp_state is currently 2.
    mnp_rx_data();
    if (mnp_rx_frame_type() != 1) goto loc_3F480;

    if (mnp_negotiate_params() != 1) {
	  //loc_3F648;
	  mnp_build_control_frame(2);
	  mnp_tx_octet_frame();
	  return 0;
	}
    ebx = 0;
    if (mnp_fixed_field_opt_flag != 0) goto loc_3F435;

    //al = al + 6; al can only be 1 so...
    al = 7;

    lapm_control_frame[3] = 5;
    lapm_control_frame[2] = 7;
    lapm_control_frame[4] = 1;
    lapm_control_frame[5] = 1;
    lapm_control_frame[6] = 0;
    lapm_control_frame[7] = 2;
    lapm_control_frame[8] = 1;
    lapm_control_frame[9] = 0;

    goto loc_3F44F;

loc_3F435:
    al = 3;
    lapm_control_frame[3] = 5;
    lapm_control_frame[2] = 3;
    lapm_control_frame[4] = 0;
    lapm_control_frame[5] = 0;

loc_3F44F:
    al++;
    lapm_control_frame[0] = 1;
    lapm_control_frame[1] = al;

    mnp_tx_octet_frame();
    lapm_reset_timer();

    if (mnp_negotiated_mode != 3)
	  al = 1;
	else
	  al = 0;
    //0003F470		 setnz	 al

    al = al + 6;
    mnp_state = al;

    return 1;

loc_3F480:
    al = lapm_timer_expired(0x3E8);
    if (al != 1) return 1;
    al = S(0x38);
    mnp_retransmit++;
    if (al == 2) goto loc_3F4A5;
    if (al != 7) goto loc_3F4AE;

loc_3F4A5:
    if (mnp_retransmit < 5) goto loc_3F4B7;

loc_3F4AE:				 
    if (mnp_retransmit >= 2) goto loc_3F4C6;

loc_3F4B7:
    mnp_state = 1;
    return 1;

loc_3F4C6:
    ebx = 0;
    mnp_retransmit = 0;
    mnp_state = 0;
    //goto loc_3F654;
	return 0;

	//loc_3F4D9:
    al = io_dce_tx_fifo_empty();
    if (al != 1) return 1;

    al = lapm_timer_expired(0x190);
    if (al == 0) return 1;

    x_send_mail(0x78, 1, 0, 0);
    mnp_state = 7;
    return 1;

  case 2:  //loc_3F514: 

/*
0003F514		 cmp	 byte__lapm_receive_frame, 1	 ; case	0x2
0003F51B		 jz	 short loc_3F522
0003F51D		 call	 sub__mnp_rx_data_0
0003F522 
0003F522 loc_3F522:				 ; CODE	XREF: sub__mnp_background_0+181j
0003F522		 call	 sub__mnp_rx_frame_type_0
0003F527		 cmp	 al, 1
0003F529		 jnz	 short loc_3F556
0003F52B		 call	 sub__mnp_negotiate_params_0
0003F530		 cmp	 al, 1
0003F532		 jnz	 loc_3F648
0003F538		 call	 sub__mnp_build_lr_frame_0
0003F53D		 call	 sub__mnp_tx_octet_frame_0
0003F542		 call	 sub__lapm_reset_timer_0
0003F547		 mov	 dword__mnp_state, 5
0003F551		 jmp	 loc_3F859	 ; default
0003F556 ; 
0003F556 
0003F556 loc_3F556:				 ; CODE	XREF: sub__mnp_background_0+18Fj
0003F556		 cmp	 al, 0FFh
0003F558		 jnz	 short loc_3F566
0003F55A		 mov	 byte__mnp_disconnect_code, 1
0003F561		 jmp	 loc_3F648
0003F566 ; 
0003F566 
0003F566 loc_3F566:				 ; CODE	XREF: sub__mnp_background_0+1BEj
0003F566		 push	 1388h
0003F56B		 call	 sub__lapm_timer_expired_4
0003F570		 cmp	 al, 1
0003F572		 jnz	 loc_3F859	 ; default
0003F578		 jmp	 loc_3F654
0003F57D ; 
0003F57D 
0003F57D loc_3F57D:				 ; CODE	XREF: sub__mnp_background_0+15j
0003F57D					 ; DATA	XREF: .text:0003F85Fo
0003F57D		 call	 sub__mnp_rx_data_0	 ; case	0x4
0003F582		 call	 sub__mnp_rx_frame_type_0
0003F587		 cmp	 al, 5
0003F589		 mov	 [ebp+var_1], al
0003F58C		 jnz	 short loc_3F5F3
0003F58E		 mov	 al, byte__mnp_k
0003F593		 xor	 ebx, ebx
0003F595		 cmp	 byte__mnp_negotiated_mode, 3
0003F59C		 mov	 byte__mnp_retransmit, bl
0003F5A2		 mov	 byte__mnp_vra, 1
0003F5A9		 mov	 byte__mnp_vsa, 1
0003F5B0		 mov	 byte__mnp_vr, 1
0003F5B7		 mov	 byte__mnp_vs, 1
0003F5BE		 mov	 byte__mnp_sk, al
0003F5C3		 mov	 byte__mnp_rk, al
0003F5C8		 jnz	 short loc_3F5D5
0003F5CA		 push	 ebx
0003F5CB		 push	 ebx
0003F5CC		 push	 1
0003F5CE		 push	 78h
0003F5D0		 call	 sub__x_send_mail_16
0003F5D5 
0003F5D5 loc_3F5D5:				 ; CODE	XREF: sub__mnp_background_0+22Ej
0003F5D5		 push	 5
0003F5D7		 mov	 byte__mnp_k, bl
0003F5DD		 call	 sub__mnp_tx_control_frame_4
0003F5E2		 call	 sub__mnp_reset_flow_timer_0
0003F5E7		 mov	 dword__mnp_state, 4
0003F5F1		 jmp	 short loc_3F622
0003F5F3 ; 
0003F5F3 
0003F5F3 loc_3F5F3:				 ; CODE	XREF: sub__mnp_background_0+1F2j
0003F5F3		 mov	 esi, 1388h
0003F5F8		 push	 esi
0003F5F9		 call	 sub__lapm_timer_expired_4
0003F5FE		 xor	 ebx, ebx
0003F600		 cmp	 al, 1
0003F602		 jnz	 short loc_3F60C
0003F604		 cmp	 byte__mnp_retransmit, bl
0003F60A		 jz	 short loc_3F612
0003F60C 
0003F60C loc_3F60C:				 ; CODE	XREF: sub__mnp_background_0+268j
0003F60C		 cmp	 [ebp+var_1], 1
0003F610		 jnz	 short loc_3F62C
0003F612 
0003F612 loc_3F612:				 ; CODE	XREF: sub__mnp_background_0+270j
0003F612		 call	 sub__mnp_build_lr_frame_0
0003F617		 call	 sub__mnp_tx_octet_frame_0
0003F61C		 inc	 byte__mnp_retransmit
0003F622 
0003F622 loc_3F622:				 ; CODE	XREF: sub__mnp_background_0+257j
0003F622		 call	 sub__lapm_reset_timer_0
0003F627		 jmp	 loc_3F859	 ; default
0003F62C ; 

0003F62C 
0003F62C loc_3F62C:				 ; CODE	XREF: sub__mnp_background_0+276j
0003F62C		 push	 esi
0003F62D		 call	 sub__lapm_timer_expired_4
0003F632		 cmp	 al, 1
0003F634		 jnz	 short loc_3F63E
0003F636		 mov	 byte__mnp_retransmit, bl
0003F63C		 jmp	 short loc_3F648
0003F63E ; 
0003F63E 
0003F63E loc_3F63E:				 ; CODE	XREF: sub__mnp_background_0+29Aj
0003F63E		 cmp	 [ebp+var_1], 0FFh
0003F642		 jnz	 loc_3F859	 ; default
0003F648 
0003F648 loc_3F648:				 ; CODE	XREF: sub__mnp_background_0+53j
0003F648					 ; sub__mnp_background_0+198j ...
0003F648		 push	 2
0003F64A		 call	 sub__mnp_build_control_frame_4
0003F64F		 call	 sub__mnp_tx_octet_frame_0
0003F654 
0003F654 loc_3F654:				 ; CODE	XREF: sub__mnp_background_0+13Aj
0003F654					 ; sub__mnp_background_0+1DEj
0003F654		 xor	 al, al
0003F656		 jmp	 loc_3F85B
0003F65B ; 
0003F65B 
0003F65B loc_3F65B:				 ; CODE	XREF: sub__mnp_background_0+15j
0003F65B					 ; DATA	XREF: .text:0003F85Fo
0003F65B		 push	 12Ch		 ; case	0x3
0003F660		 call	 sub__lapm_timer_expired_4
0003F665		 test	 al, al
0003F667		 jz	 loc_3F859	 ; default
0003F66D		 mov	 al, byte__mnp_sk
0003F672		 xor	 ebx, ebx
0003F674		 mov	 dword__mnp_state, 8
0003F67E		 mov	 byte__mnp_first_lt_flag, bl
0003F684		 mov	 byte__mnp_k, al
0003F689		 jmp	 short loc_3F6CD
0003F68B ; 
0003F68B 
0003F68B loc_3F68B:				 ; CODE	XREF: sub__mnp_background_0+15j
0003F68B					 ; DATA	XREF: .text:0003F85Fo
0003F68B		 mov	 al, byte__mnp_k	 ; case	0x6
0003F690		 xor	 ebx, ebx
0003F692		 mov	 dword__mnp_state, 8
0003F69C		 mov	 byte__mnp_first_lt_flag, bl
0003F6A2		 mov	 byte__mnp_vsa, 1
0003F6A9		 mov	 byte__mnp_vra, 1
0003F6B0		 mov	 byte__mnp_vs, 1
0003F6B7		 mov	 byte__mnp_vr, 1
0003F6BE		 mov	 byte__mnp_sk, al
0003F6C3		 mov	 byte__mnp_rk, al
0003F6C8		 mov	 byte__mnp_nk, al
0003F6CD 
0003F6CD loc_3F6CD:				 ; CODE	XREF: sub__mnp_background_0+2EFj
0003F6CD		 push	 5
0003F6CF		 call	 sub__mnp_tx_control_frame_4
0003F6D4		 call	 sub__mnp_reset_flow_timer_0
0003F6D9		 movzx	 eax, byte__mnp_negotiated_service
0003F6E0		 push	 200h
0003F6E5		 mov	 dword__x_modem_ec, eax
0003F6EA		 call	 nullsub_2
0003F6EF		 push	 ebx
0003F6F0		 push	 ebx
0003F6F1		 push	 2
0003F6F3		 push	 1Ch
0003F6F5		 jmp	 loc_3F854
0003F6FA ; 
0003F6FA 
0003F6FA loc_3F6FA:				 ; CODE	XREF: sub__mnp_background_0+15j
0003F6FA					 ; DATA	XREF: .text:0003F85Fo
0003F6FA		 call	 sub__mnp_rx_data_0	 ; case	0x7
0003F6FF		 call	 sub__mnp_rx_frame_type_0
0003F704		 push	 0Ah
0003F706		 cmp	 al, 2
0003F708		 mov	 [ebp+var_1], al
0003F70B		 pop	 esi
0003F70C		 jnz	 short loc_3F719
0003F70E		 mov	 dword__mnp_state, esi
0003F714		 call	 sub__lapm_reset_timer_0
0003F719 
0003F719 loc_3F719:				 ; CODE	XREF: sub__mnp_background_0+372j
0003F719		 xor	 ebx, ebx
0003F71B		 cmp	 byte__io_at_esc_detect, bl
0003F721		 jnz	 short loc_3F72D
0003F723		 call	 sub__mnp_process_lt_frame_0
0003F728		 call	 sub__mnp_build_lt_frame_0
0003F72D 
0003F72D loc_3F72D:				 ; CODE	XREF: sub__mnp_background_0+387j
0003F72D		 cmp	 byte__mnp_negotiated_mode, 3
0003F734		 jnz	 short loc_3F73D
0003F736		 call	 sub__mnp_tx_hdlc_frame_0
0003F73B		 jmp	 short loc_3F742
0003F73D ; 
0003F73D 
0003F73D loc_3F73D:				 ; CODE	XREF: sub__mnp_background_0+39Aj
0003F73D		 call	 sub__mnp_tx_octet_frame_0
0003F742 
0003F742 loc_3F742:				 ; CODE	XREF: sub__mnp_background_0+3A1j
0003F742		 cmp	 [ebp+var_1], 4
0003F746		 jnz	 short loc_3F751
0003F748		 cmp	 byte__mnp_seq_recover_flag, 1
0003F74F		 jz	 short loc_3F75F
0003F751 
0003F751 loc_3F751:				 ; CODE	XREF: sub__mnp_background_0+3ACj
0003F751		 push	 0BB8h
0003F756		 call	 sub__mnp_flow_timer_expired_4
0003F75B		 cmp	 al, 1
0003F75D		 jnz	 short loc_3F793
0003F75F 
0003F75F loc_3F75F:				 ; CODE	XREF: sub__mnp_background_0+3B5j
0003F75F		 cmp	 byte__lapm_local_busy, bl
0003F765		 jnz	 short loc_3F77B
0003F767		 cmp	 byte__io_at_esc_detect, bl
0003F76D		 jnz	 short loc_3F77B
0003F76F		 mov	 al, byte__mnp_rk
0003F774		 mov	 byte__mnp_nk, al
0003F779		 jmp	 short loc_3F781
0003F77B ; 
0003F77B 
0003F77B loc_3F77B:				 ; CODE	XREF: sub__mnp_background_0+3CBj
0003F77B					 ; sub__mnp_background_0+3D3j
0003F77B		 mov	 byte__mnp_nk, bl
0003F781 
0003F781 loc_3F781:				 ; CODE	XREF: sub__mnp_background_0+3DFj
0003F781		 push	 5
0003F783		 call	 sub__mnp_tx_control_frame_4
0003F788		 mov	 byte__mnp_seq_recover_flag, bl
0003F78E		 call	 sub__mnp_reset_flow_timer_0
0003F793 
0003F793 loc_3F793:				 ; CODE	XREF: sub__mnp_background_0+3C3j
0003F793		 push	 1388h
0003F798		 call	 sub__lapm_timer_expired_4
0003F79D		 cmp	 al, 1
0003F79F		 jnz	 loc_3F859	 ; default
0003F7A5		 call	 sub__lapm_reset_timer_0
0003F7AA		 cmp	 byte__lapm_remote_busy, bl
0003F7B0		 jnz	 loc_3F859	 ; default
0003F7B6		 mov	 al, byte__mnp_ns
0003F7BB		 mov	 cl, byte__mnp_last_ack
0003F7C1		 cmp	 al, cl
0003F7C3		 jz	 loc_3F859	 ; default
0003F7C9		 movzx	 ax, al
0003F7CD		 jnb	 short loc_3F7D4
0003F7CF		 add	 eax, 100h
0003F7D4 
0003F7D4 loc_3F7D4:				 ; CODE	XREF: sub__mnp_background_0+433j
0003F7D4		 sub	 al, cl
0003F7D6		 add	 byte__mnp_sk, al
0003F7DC		 inc	 byte__lapm_retransmit
0003F7E2		 cmp	 byte__lapm_retransmit, 0Ch
0003F7E9		 jb	 short loc_3F7F3
0003F7EB		 mov	 dword__mnp_state, esi
0003F7F1		 jmp	 short loc_3F859 ; default
0003F7F3 ; 
0003F7F3 
0003F7F3 loc_3F7F3:				 ; CODE	XREF: sub__mnp_background_0+44Fj
0003F7F3		 mov	 byte__mnp_ns, cl
0003F7F9		 jmp	 short loc_3F859 ; default
0003F7FB ; 
0003F7FB 
0003F7FB loc_3F7FB:				 ; CODE	XREF: sub__mnp_background_0+15j
0003F7FB					 ; DATA	XREF: .text:0003F85Fo
0003F7FB		 push	 2		 ; case	0x8
0003F7FD		 call	 sub__mnp_tx_control_frame_4
0003F802		 push	 0C8h
0003F807		 call	 sub__lapm_timer_expired_4
0003F80C		 cmp	 al, 1
0003F80E		 jnz	 short loc_3F859 ; default
0003F810		 xor	 ebx, ebx
0003F812		 push	 ebx
0003F813		 call	 nullsub_2
0003F818		 push	 ebx
0003F819		 push	 ebx
0003F81A		 push	 1
0003F81C		 mov	 dword__mnp_state, 0Bh
0003F826		 push	 9
0003F828		 jmp	 short loc_3F854
0003F82A ; 
0003F82A 
0003F82A loc_3F82A:				 ; CODE	XREF: sub__mnp_background_0+15j
0003F82A					 ; DATA	XREF: .text:0003F85Fo
0003F82A		 push	 2		 ; case	0x9
0003F82C		 call	 sub__mnp_tx_control_frame_4
0003F831		 push	 64h
0003F833		 call	 sub__lapm_timer_expired_4
0003F838		 cmp	 al, 1
0003F83A		 jnz	 short loc_3F859 ; default
0003F83C		 xor	 ebx, ebx
0003F83E		 push	 ebx
0003F83F		 call	 nullsub_2
0003F844		 push	 ebx
0003F845		 push	 ebx
0003F846		 push	 1
0003F848		 mov	 dword__mnp_state, 0Bh
0003F852		 push	 1Bh
0003F854 
0003F854 loc_3F854:				 ; CODE	XREF: sub__mnp_background_0+35Bj
0003F854					 ; sub__mnp_background_0+48Ej
0003F854		 call	 sub__x_send_mail_1
*/
  }

  //loc_3F859:
  return 1;
}

/*
0003F85F off_3F85F	 dd offset loc_3F3B6	 ; DATA	XREF: sub__mnp_background_0+15r
0003F85F		 dd offset loc_3F3D4	 ; jump	table for switch statement
0003F85F		 dd offset loc_3F514
0003F85F		 dd offset loc_3F65B
0003F85F		 dd offset loc_3F57D
0003F85F		 dd offset loc_3F4D9
0003F85F		 dd offset loc_3F68B
0003F85F		 dd offset loc_3F6FA
0003F85F		 dd offset loc_3F7FB
0003F85F		 dd offset loc_3F82A
0003F887		 align 4
*/


unsigned char mnp_rx_frame_type(void)
{
  printf("mnp_frame_type: Warning not implemented yet!\n");
  return 0;
}

unsigned char mnp_negotiate_params(void)
{
  printf("mnp_negotiate_params: Warning not implemented yet!\n");
  return 0;
}

/*

0003F1D5		 align 2
000_
000_mnp_negotiate_params_0 
000_mnp_negotiate_params_0 ;		 S u b r o u t i n e
000_mnp_negotiate_params_0 
000_mnp_negotiate_params_0 sub_3F1D6	 proc near		 ; CODE	XREF: sub__mnp_background_0+4Cp
000_mnp_negotiate_params_0					 ; sub__mnp_background_0+191p
000_mnp_negotiate_params_0		 cmp	 byte_51D68, 2
0003F1DD		 push	 ebx
0003F1DE		 jz	 short loc_3F1EC
0003F1E0		 mov	 byte__mnp_disconnect_code, 2
0003F1E7		 jmp	 loc_3F31C
0003F1EC 
0003F1EC loc_3F1EC:				 ; CODE	XREF: sub__mnp_negotiate_params_0+8j
0003F1EC		 cmp	 byte_51D69, 1
0003F1F3		 jnz	 loc_3F30C
0003F1F9		 cmp	 byte_51D6A, 6
0003F200		 jnz	 loc_3F30C
0003F206		 mov	 al, byte__mnp_rx_framing_mode
0003F20B		 cmp	 al, 3
0003F20D		 jz	 short loc_3F217
0003F20F		 cmp	 al, 2
0003F211		 jnz	 loc_3F30C
0003F217 
0003F217 loc_3F217:				 ; CODE	XREF: sub__mnp_negotiate_params_0+37j
0003F217		 mov	 cl, byte__mnp_framing_mode
0003F21D		 mov	 byte__mnp_negotiated_mode, al
0003F222		 cmp	 al, cl
0003F224		 jb	 short loc_3F22C
0003F226		 mov	 byte__mnp_negotiated_mode, cl
0003F22C 
0003F22C loc_3F22C:				 ; CODE	XREF: sub__mnp_negotiate_params_0+4Ej
0003F22C		 mov	 al, byte__mnp_rx_k
0003F231		 cmp	 al, 1
0003F233		 jb	 loc_3F30C
0003F239		 cmp	 al, 0FFh
0003F23B		 ja	 loc_3F30C
0003F241		 cmp	 al, byte__mnp_k
0003F247		 jnb	 short loc_3F24E
0003F249		 mov	 byte__mnp_k, al
0003F24E 
0003F24E loc_3F24E:				 ; CODE	XREF: sub__mnp_negotiate_params_0+71j
0003F24E		 xor	 bl, bl
0003F250		 cmp	 byte__mnp_rx_data_opt_flag, bl
0003F256		 jz	 short loc_3F267
0003F258		 cmp	 byte__mnp_data_opt_flag, bl
0003F25E		 mov	 byte__mnp_data_opt_flag, 1
0003F265		 jnz	 short loc_3F26D
0003F267 
0003F267 loc_3F267:				 ; CODE	XREF: sub__mnp_negotiate_params_0+80j
0003F267		 mov	 byte__mnp_data_opt_flag, bl
0003F26D 
0003F26D loc_3F26D:				 ; CODE	XREF: sub__mnp_negotiate_params_0+8Fj
0003F26D		 cmp	 byte__mnp_rx_stream_opt_flag, bl
0003F273		 jz	 short loc_3F284
0003F275		 cmp	 byte__mnp_stream_opt_flag, bl
0003F27B		 mov	 byte__mnp_stream_opt_flag, 1
0003F282		 jnz	 short loc_3F28A
0003F284 
0003F284 loc_3F284:				 ; CODE	XREF: sub__mnp_negotiate_params_0+9Dj
0003F284		 mov	 byte__mnp_stream_opt_flag, bl
0003F28A 
0003F28A loc_3F28A:				 ; CODE	XREF: sub__mnp_negotiate_params_0+ACj
0003F28A		 cmp	 byte__mnp_rx_fixed_field_opt_flag, bl
0003F290		 jz	 short loc_3F2A1
0003F292		 cmp	 byte__mnp_fixed_field_opt_flag, bl
0003F298		 mov	 byte__mnp_fixed_field_opt_flag, 1
0003F29F		 jnz	 short loc_3F2A7
0003F2A1 
0003F2A1 loc_3F2A1:				 ; CODE	XREF: sub__mnp_negotiate_params_0+BAj
0003F2A1		 mov	 byte__mnp_fixed_field_opt_flag, bl
0003F2A7 
0003F2A7 loc_3F2A7:				 ; CODE	XREF: sub__mnp_negotiate_params_0+C9j
0003F2A7		 cmp	 byte__mnp_rx_data_compression, bl
0003F2AD		 jz	 short loc_3F2C5
0003F2AF		 cmp	 byte__mnp_data_compression, bl
0003F2B5		 jz	 short loc_3F2C5
0003F2B7		 mov	 byte__mnp_data_compression, 1
0003F2BE		 call	 sub__mnp5_ad_frq_init_0
0003F2C3		 jmp	 short loc_3F2CB
0003F2C5 
0003F2C5 loc_3F2C5:				 ; CODE	XREF: sub__mnp_negotiate_params_0+D7j
0003F2C5					 ; sub__mnp_negotiate_params_0+DFj
0003F2C5		 mov	 byte__mnp_data_compression, bl
0003F2CB 
0003F2CB loc_3F2CB:				 ; CODE	XREF: sub__mnp_negotiate_params_0+EDj
0003F2CB		 cmp	 byte__mnp_data_compression, 1
0003F2D2		 jnz	 short loc_3F2DD
0003F2D4		 mov	 byte__mnp_negotiated_service, 6
0003F2DB		 jmp	 short loc_3F308
0003F2DD 
0003F2DD loc_3F2DD:				 ; CODE	XREF: sub__mnp_negotiate_params_0+FCj
0003F2DD		 cmp	 byte__mnp_fixed_field_opt_flag, bl
0003F2E3		 jnz	 short loc_3F301
0003F2E5		 cmp	 byte__mnp_stream_opt_flag, bl
0003F2EB		 jnz	 short loc_3F301
0003F2ED		 cmp	 byte__mnp_negotiated_mode, 3
0003F2F4		 setz	 al
0003F2F7		 add	 eax, 3
0003F2FA		 mov	 byte__mnp_negotiated_service, al
0003F2FF		 jmp	 short loc_3F308
0003F301 
0003F301 loc_3F301:				 ; CODE	XREF: sub__mnp_negotiate_params_0+10Dj
0003F301					 ; sub__mnp_negotiate_params_0+115j
0003F301		 mov	 byte__mnp_negotiated_service, 5
0003F308 
0003F308 loc_3F308:				 ; CODE	XREF: sub__mnp_negotiate_params_0+105j
0003F308					 ; sub__mnp_negotiate_params_0+129j
0003F308		 mov	 al, 1
0003F30A		 pop	 ebx
0003F30B		 retn	 
0003F30C 
0003F30C loc_3F30C:				 ; CODE	XREF: sub__mnp_negotiate_params_0+1Dj
0003F30C					 ; sub__mnp_negotiate_params_0+2Aj ...
0003F30C		 cmp	 byte__x_modem_originate, 1
0003F313		 jnz	 short loc_3F31C
0003F315		 mov	 byte__mnp_disconnect_code, 3
0003F31C 
0003F31C loc_3F31C:				 ; CODE	XREF: sub__mnp_negotiate_params_0+11j
0003F31C					 ; sub__mnp_negotiate_params_0+13Dj
0003F31C		 xor	 al, al
0003F31E		 pop	 ebx
0003F31F		 retn	 
0003F31F sub__mnp_negotiate_params_0	 endp


000_mnp5_ad_frq_tx_init_0 
000_mnp5_ad_frq_tx_init_0 ;		 S u b r o u t i n e
000_mnp5_ad_frq_tx_init_0 
000_mnp5_ad_frq_tx_init_0 sub_4088E	 proc near		 ; CODE	XREF: sub__mnp5_ad_frq_init_0p
000_mnp5_ad_frq_tx_init_0		 push	 ebx
0004088F		 push	 esi
00040890		 xor	 ebx, ebx
00040892		 xor	 edx, edx
00040894		 xor	 eax, eax
00040896		 mov	 esi, offset word__child
0004089B 
0004089B loc_4089B:				 ; CODE	XREF: sub__mnp5_ad_frq_tx_init_0+37j
0004089B		 movzx	 ecx, dx
0004089E		 inc	 edx
0004089F		 mov	 [esi],	ax
000408A2		 mov	 byte__parent[ecx], bl
000408A8		 mov	 byte__symbol[ecx], bl
000408AE		 movzx	 ecx, dx
000408B1		 inc	 edx
000408B2		 mov	 byte__parent[ecx], al
000408B8		 mov	 byte__symbol[ecx], al
000408BE		 inc	 eax
000408BF		 inc	 esi
000408C0		 inc	 esi
000408C1		 cmp	 ax, 100h
000408C5		 jb	 short loc_4089B
000408C7		 mov	 byte__mnp5_run_length_match_char, bl
000408CD		 mov	 byte__mnp5_run_length_repeat_count, bl
000408D3		 mov	 byte__mnp5_run_length_flag, bl
000408D9		 mov	 byte__mnp5_repeat_count, bl
000408DF		 mov	 byte__mnp5_tx_token_byte, bl
000408E5		 pop	 esi
000408E6		 mov	 byte__mnp5_run_length_count, 3
000408ED		 mov	 byte__mnp5_bitpos, 80h
000408F4		 pop	 ebx
000408F5		 retn	 
000408F5 sub__mnp5_ad_frq_tx_init_0	 endp
*/


void mnp_build_lr_frame(void)
{
  printf("mnp_build_lr_frame: Warning not yet implemented!\n");
}

void mnp_build_control_frame(unsigned char arg1)
{
  printf("mnp_control_frame(%d): Warning not yet implemented!\n", arg1);
}

void mnp_tx_octet_frame(void)
{
  printf("mnp_tx_octet_frame: Warning not yet implemented!\n");
}
void mnp_rx_data(void)
{
  printf("mnp_rx_data: Warning not yet implemented!\n");
}



