/*
 * Header file for main modem global variables.
 *
 * Copyright 1999 R.J.M. Close, distribute under GPL
 */

#ifndef	LT_GLOBALS_H
#define	LT_GLOBALS_H

#include "stdbool.h"
#ifndef INIT_C
#define EXTERN extern
#define I(a...)
#else
#undef EXTERN
#undef I
#define EXTERN /**/
#define I(a...) = a
#endif

#ifndef MOD
#define MOD(a, b) = a % b
#endif

// Type defs.
#ifndef INIT_C

struct lt_timer {
          unsigned short t_min;
          unsigned short t_msec;
       };

enum {
  DIAL_INIT,
  DIAL_1,
  DIAL_WAITING_FOR_DIALTONE,
  DIAL_WAITING_FOR_W_DIALTONE,
  DIAL_HOOK_FLASH,
  DIAL_HOOK_FLASH_RECOVERY,
  DIAL_CHECKING_QUIET_ANSWER,
  DIAL_WAITING_FOR_BONG,
  DIAL_DIGIT,
  DIAL_PAUSE,
  DIAL_DIGIT_RECOVERY
} dp_dial_state;

#endif

// Variable defs.
EXTERN bool isapnp_modem I(false);
EXTERN unsigned char modem_enabled;

EXTERN unsigned char cell_active;

EXTERN volatile unsigned char dp_byte_f, dp_byte_e, dp_byte_d, dp_byte_c;

// Shadows of registers 0xd7 and 0xbc
EXTERN volatile unsigned char dp_bamil_rd7, dp_bamil_rbc;

EXTERN volatile unsigned char dp_dsp_data_in_progress, dp_sleep, CpqFlag, dp_state;
EXTERN unsigned char dp_dsp_status I(0);

// Ring related stuff.
EXTERN unsigned char dp_count;
EXTERN unsigned char dp_ring_int_count, dp_ring_int;

// 56K related stuff.
EXTERN int dp_56k_state;

// Tone detection stuff.
EXTERN unsigned short peak_energy, peak_busy_energy;
EXTERN unsigned int dp_busy_state, dp_tone_state;
EXTERN unsigned char dp_threshold;

EXTERN bool x_dsp_mars;
EXTERN bool x_dsp_mars3 I(false);  // Not yet set up properly!

EXTERN unsigned char dp_tad_downloaded, dp_fax_downloaded, dp_first_call, dp_redial;

EXTERN unsigned char dp_busy_cycles;
EXTERN unsigned char dp_dial_string[256];
EXTERN unsigned char* dp_dial_ptr;
EXTERN unsigned short dp_max_pause, dp_continous_busy_timer;
EXTERN unsigned short dp_tone_timer;
EXTERN unsigned short dp_tone_on_time, dp_tone_off_time;
EXTERN unsigned char dp_dialtone_cycles;

EXTERN unsigned short dp_answer_state;

EXTERN unsigned int x_chip_version, dp_version;

EXTERN unsigned int dp_cmd_timer, dp_local_phone_timer;
EXTERN unsigned int dp_dial_tone_timer, dp_quiet_answer_timer, dp_busy_tone_timer;

EXTERN unsigned short S_0x81 I(0);

// x_status diagnostics array, I'm not sure about the length!
// see: at_init_diagnostics.
EXTERN unsigned char x_status[0x50];
//  x_status[1] is the connection state?
//  x_status[2,3] = x_line_rate_tx;
//  x_status[4,5] = x_line_rate;



// V8 cl message ? I'm not sure about the length!
EXTERN unsigned char rx_v8bis_cl_msg[0x20];
EXTERN unsigned char V8bis_Options[10];
EXTERN unsigned char v8bis_state;

// I/O specific stuff.
EXTERN unsigned int io_state, io_at_esc_state;
EXTERN unsigned short io_uart_status;
EXTERN unsigned char io_old_state, io_send_break_to_remote;
EXTERN unsigned char io_uart_msr, io_remote_control_mode, io_at_esc_detect;

// DCE RX Buffer.
EXTERN unsigned char io_dce_rx_buff[0x1001];

// Pointers used on the dce RX buffer.
EXTERN unsigned char *io_dce_rx_rptr, *io_dce_rx_wptr;
EXTERN unsigned char *io_dce_rx_eptr, *io_dce_rx_sptr;
EXTERN unsigned char* io_dce_rx_last_ch;

// DCE TX Buffer.
EXTERN unsigned char io_dce_tx_buff[0x1001];

// Pointers used on the dce TX buffer.
EXTERN unsigned char *io_dce_tx_rptr, *io_dce_tx_wptr;
EXTERN unsigned char *io_dce_tx_eptr, *io_dce_tx_sptr;
EXTERN unsigned char* io_dce_tx_last_ch;

// DTE RX Buffer.
EXTERN unsigned char io_dte_rx_buff[0x1001];

// Pointers used on the dte RX buffer.
EXTERN unsigned char *io_dte_rx_rptr, *io_dte_rx_wptr;
EXTERN unsigned char *io_dte_rx_eptr, *io_dte_rx_sptr;
EXTERN unsigned char* io_dte_rx_last_ch;
EXTERN unsigned char* io_dte_rx_old_ptr;

// DTE TX Buffer.
EXTERN unsigned char io_dte_tx_buff[0x1001];

// Pointers used on the dte TX buffer.
EXTERN unsigned char *io_dte_tx_rptr, *io_dte_tx_wptr;
EXTERN unsigned char *io_dte_tx_eptr, *io_dte_tx_sptr;
EXTERN unsigned char* io_dte_tx_last_ch;
EXTERN unsigned char* io_dte_tx_old_ptr;

// App RX Pointers
EXTERN unsigned char *io_app_tx_eptr, *io_app_tx_sptr;

// Misc IO pointers.
EXTERN unsigned char* io_esc_dte_wptr;
EXTERN unsigned char* old_app_pqTx;

// Buffer size?
EXTERN unsigned short old_app_cbqTx;
EXTERN unsigned char io_app_tx_data_update;

// Upper 2 bytes hold millisec's, bottom 2 hold sec's.
EXTERN struct lt_timer io_dte_inact_timer;

// Moved from init.c !

EXTERN unsigned short word_59E9E, word_59E9C;

EXTERN unsigned char x_test_mode_on, x_parity_mask, x_dma_xfer;

EXTERN unsigned char x_parameter_mode;

EXTERN unsigned char country_name[40];

// Other stuff.

EXTERN unsigned char D3Flag, dp_calling_tone_disable, DpIdleFillChar, dp_fdsp_record;
EXTERN unsigned char dp_failures, dp_blacklist_calls;

EXTERN int x_modem_state, x_dial_residual;

EXTERN short dp_wDspRetrainState;

EXTERN unsigned char V34Mode I(0);
EXTERN unsigned short dp_wV34Option I(0);

// AT specific stuff.
EXTERN unsigned int at_result_code, at_state;
EXTERN unsigned char at_cmd_buf, at_connect_code_flag, at_view_more;
EXTERN unsigned short at_cmd_len, at_timer;
EXTERN unsigned char* at_cmd_ptr;

  // FIXME:
  // Yuk, look up table.
  // lea esi, loc_iircoef[eax*2], array of unsigned short.
  // starts at 10560, needs filling in!
EXTERN unsigned short iircoef[128] I(
 { 0x2480, 0x8f16, 0x39a8, 0x0000, 0xfbf0, 0x0410, 0x91aa, 0x3cd5, 0xed1d, 0x0bd4,
   0x0bd4, 0x878e, 0x3dfe, 0xa5c3, 0x2e40, 0x2e40, 0x1f60, 0x8a1b, 0x3d11, 0x0000,
   0xfd50, 0x02b0, 0x8bf1, 0x3e72, 0xeeda, 0x0a48, 0x0a48, 0x862a, 0x3ee6, 0xa53e, // 1059B
   0x2e43, 0x2e43, 0x2480, 0x8b07, 0x3ce9, 0x0000, 0xfe10, 0x01e3, 0x8ce3, 0x3e6a,
   0xe94c, 0x0d71, 0x0d71, 0x8834, 0x3ebe, 0xb32a, 0x27a3, 0x27a3, 0x3180, 0x8b5f, // 105c3
   0x3b2a, 0x0000, 0xfc37, 0x03c9, 0x8d40, 0x3d2a, 0xf9a6, 0x04a0, 0x04a0, 0x8613, // 105d7
   0x3e2b, 0xb62b, 0x2536, 0x2536, 0x0a00, 0x8a5b, 0x3ebf, 0x0000, 0xff53, 0x00ad,
   0x8aba, 0x3f5e, 0xe42e, 0x0fc4, 0x0fc4, 0x88de, 0x3f6c, 0xb3bd, 0x27db, 0x27db, // 105ff
   0x3150, 0x91ed, 0x3704, 0x0000, 0xf84e, 0x07b2, 0x97ae, 0x3ab5, 0xfa26, 0x0505,
   0x0505, 0x8763, 0x3d3d, 0xb7b4, 0x2491, 0x2491, 0x1f60, 0x8d12, 0x3c01, 0x0000,
   0xfdc2, 0x023e, 0x8e96, 0x3e45, 0xdeb8, 0x1353, 0x1353, 0x87e6, 0x3ebd, 0x82c3,
   0x4116, 0x4116, 0x8140, 0x9fee, 0x2f93, 0x0000, 0xee26, 0x11da, 0xbcae, 0x37e6,
   0xfe51, 0x03d5, 0x03d5, 0x87b3, 0x3d2d, 0xaad0, 0x2b58, 0x2b58 } );
 

// End of variable definitions.
//**********************************



//
// S[] array starts at byte_59E60. I'm not sure where it ends
// but it should be at least 48 entries long. Lets assume it ends
// at byte_59E9B.
//
// Register S0 actually exists. that's good.
//
/*
S0         Auto Answer Ring Number
S1         Ring Counter
S2         AT Escape Character (user defined)
S3         Command Line Termination Character (user defined)
S4         Response Formatting Character (user defined)
S5         Command Line Editing Character (user defined)
S6         Wait Before Dialing
S7         Connection Completion Time-Out
S8         Comma Dial Modifier Time
S10        Automatic Disconnect Delay
S11        DTMF Dialing Speed
S12        Escape Guard Time
S14        General Bit Mapped Options Status
S21        V.24/General Bit Mapped Options Status
S22        Results Bit Mapped Options Status
S24        Timer to Control Sleep Mode
S28        V.34 Modulation Enable/Disable
S30        Inactivity Timer
S32        Synthetic Ring Volume
S33        Synthetic Ring Frequency
S35        Data Calling Tone
S37        Dial Line Rate (default 0)
S38        K56flex Downstream Rate
S42        Auto Rate (default 1, range 0 1)
S43        Auto Mode (default 1, range 0 1)
S48        LAPM Error Control and Feature Negotiation (default 7)
S89        Timer to Control Sleep Mode
S90        Read-only Local Phone
S91        Line Transmit Level
S108       Network Codec Type
 */

EXTERN unsigned char S[0x9B-0x60];

/*
 * byte_59EE7 is start of international table, documented in v90atcom.txt.
 *
 * homol[0] is dummy, I really want it numbered from 1 
 *
 * Here is what values mean
 
 Par #                      Parameter Description                                      Range              Reference
   1      Pulse dial make time                                           0-255                            ATD
   2      Pulse dial break time                                          0-255                            ATD
   3      Pulse dial digit pattern                                       1 = normal, 2 = Sweden,          ATD
                                                                         3 = Norway
   4      DTMF high tone level in dB with implied minus sign             0-255                            ATD
   5      Min. DTMF dial speed in ms                                     0-255                            S11
   6      Max. DTMF dial speed in ms                                     0-255                            S11
   7      Call progress detection threshold in dB with implied minus 0-255
          sign
   8      Dial tone delay, i.e., waiting time before dial tone           0-255
          detection begins in multiples of 10 ms
   9      Dial tone hole time in ms                                      0-255
   a      Delay before resetting ring count to 0, in multiples of 100    0-255
          ms
   b      Min. ring count for auto-answer                                0-255                            S0
   c      Max. ring count for auto-answer                                0-255                            S0
   d      Min. ring signal period =                                      0-255
          1000/(0.833 x Max. ring frequency)
   e      Max. ring signal period =                                      0-255
          1000/(0.833 x Min. ring frequency)
    f     Min. ring cadence on time, in multiples of 10 ms               0-255
   10     Min ring cadence off time, in multiple of 20 ms                0-255
   11     Min. busy cadence on time, in multiples of 10 ms               0-255; If 0, use the standard
                                                                         busy detection algorithm;
                                                                         otherwise, use the country
                                                                         specific values for cadence
   12     Max. busy cadence on time, in multiples of 10 ms               0-255; If 0, use the standard
                                                                         busy detection algorithm;
                                                                         otherwise, use the country
                                                                         specific values for cadence
   13     Number of busy cycles required to detect busy condition        0-255
   14     Min. busy cadence off time, in multiples of 10 ms              0-255; If 0, use the standard
                                                                         busy detection algorithm;
                                                                         otherwise, use the country
                                                                         specific values for cadence
   15     Max. busy cadence off time, in multiples of 10 ms              0-255; If 0, use the standard
                                                                         busy detection algorithm;
                                                                         otherwise, use the country
                                                                         specific values for cadence
   16     Continuous # unavailable detection flag                        0 = disabled, 1 = enabled
   17     Answer tone validation time in multiples of  10 ms             0-255
   18     Blacklisting/delayed flag                                      0 = disabled, 1 = enabled        ATD

 Par #                  Parameter Description                                       Range                             Reference
      19    Number of failed attempts allowed before           0-255                                                  ATD
            blacklisting
      1a    Troubled call delay in minutes                     0-255                                                  ATD
      1b    Ineffective call delay in minutes                  0-255                                                  ATD
      1c    Erroneous call delay in minutes                    0-255                                                  ATD
      1d    Blacklisting duration in multiple of 10 minutes 0-255;                                                    ATD
                                                               0 = only delayed and no blacklisting
                                                               255 = no limit (i.e., till power turned off)
      1e    Over-current sense validation time in              0-255, 0 = current sense disabled.                     ATA, ATD
            multiples of 10 ms
      1f    Calling tone flag                                  0 = disabled                                           ATD , S35
                                                               1 = enabled, and disable with ^ dial
                                                                     modifier permitted
                                                               2 = enabled,  and disable with ^ dial
                                                                     modifier not permitted
      20    Blind dial flag                                    0 = not permitted                                      ATD , ATX
                                                               1 = permitted
                                                               2 = permitted with speaker on
      21    Busy detect disable (with ATX) flag                0 = not permitted                                      ATD , ATX
                                                               1 = permitted
      22    Guard tone type                                    0 = not present & adjustable                           S37
                                                               1 = 550 Hz, 2 = 1800 Hz
      23    Bell modes permitted flag                          0 = not permitted                                      ATB
                                                               1 = permitted
      24    Off-hook  (ATH1) restrictions                      0 = no restrictions                                    ATH1
                                                               1 = restricted by S7 duration
                                                               2 = not allowed
      25    Shunt relay on time during off-hook in             0-255                                                  ATD
            multiples of 10 ms.                                0 = shunt relay disabled
      26    Hook flash time in multiples of 10 ms              0-255                                                  ATD
                                                               0 = hook flash not allowed
      27    Min. blind dial pause in seconds                   0-65                                                   S6
      28    Max. blind dial pause in seconds                   0-65                                                   S6
      29    Min. no answer time-out in seconds                 0-65                                                   S7
      2a    Max. no answer time-out in seconds                 0-65                                                   S7
      2b    Min. dial pause time in seconds                    0-65                                                   S8
      2c    Max. dial pause time in seconds                    0-65                                                   S8
      2d    Min. no carrier disconnect time in multiples of 1-65                                                      S10
            100 ms
      2e    Max. no carrier disconnect time in multiples of 1-255                                                     S10
            100 ms
      2f    Transmit level in dB with implied minus sign       0-255                                                        ATD
      30    Dial modifier validation                           0 = if an invalid dial modifier is found, treat the           -
                                                               entire dial string as null (no digits dialed)
                                                               1 = ignore invalid dial modifiers

 Par #                    Parameter Description                                             Range                     Reference
  31      TAD receive gain                                          0-255                                                -
  32      Half/full wave ring detection                             0 = halfwave, 1 = fullwave                           -
  33      Number of failed attempts allowed in first stage          0-255                                               ATD
          delayed dialing
  34      Number of all failed attempts ( to any number)            0-255                                               ATD
          allowed before any further dial attempts are blocked      255 = not applicable
  35      Erroneous call increment count                            0-255                                               ATD
  36      Dial tone validation time in multiples of 100 ms          0-255                                               ATD
  37      Busy tone detection during dial tone detection flag       0 = not required, 1 = required                      ATD
  38      DTMF high and low tone level difference in dB             0-255                                                -
  39      Local phone detection in speakerphone                     0 = enabled; 1 = disabled                            -
  3a      Pulse dialing flag                                        0 = enabled; 1 = disabled                           ATD
  3b      Dial tone/call progress filter index                      0 = 340-560 Hz         1 = 310-485 Hz                -
                                                                    2 = 363-502 Hz         3 = 276-504 Hz
                                                                    4 = 415-460 Hz         5 = 310-640 Hz
   3c     Dial tone detection threshold in dB                       0-255                                                -
  3d      ABCD dialing permitted flag                               0 = permitted, 1 = not permitted                    ATD
  3e      Comma pause duration limit in seconds.  (If there are 0-255                                                   ATD
          multiple commas between digits, the total pause
          duration is limited to the duration set by this
          parameter).
   3f     TAD transmit level in dB                                  0-255                                                -
  40      Data/FAX carrier receive threshold in dB. There is a 6 0-255                                                   -
          dB offset in DSP. This parameter value should set to:
          (required threshold [6 dB] DAA gain)
  41      No dialtone time-out duration while detecting dialtone 0-255                                                  ATD
          with W dial modifier, in seconds
  42      FAX/Data answer tone detection threshold in dB            0-255                                                -
  43      Dialtone level (absolute value)                           0-255                                                -
  44      FAX receive threshold in dB                               0-255                                                -
  45      Pulse and tone dial in same dial string permitted flag    0 = permitted, 1 = not permitted                    ATD
  46      Ringer impedance relay flag                               0 = off, 1 = on
  47      DC loop V/I characteristics relay flag                    0 = off, 1 = on
  48      DC loop limiting relay flag                               0 = off, 1 = on
  49      Real/complex impedance                                    0x0X = real, Tx & Rx gains set by mercury
                                                                    internal components. X = Don't care
                                                                    0x10 = real,  Tx gain set by mercury
                                                                    internal components & Rx gain set by
                                                                    external components.
                                                                    0x12 = complex, Tx gain set by mercury
                                                                    internal components & Rx gain set by
                                                                    external components. Mercury internal
                                                                    switch used to select complex impedance.
  4a      Mercury register CIOCA MSB value-receive gain             This parameter is relevant only when a Mercury       -
                                                                    line codec is used.
 Par #                   Parameter Description                                        Range                      Reference
      4b    Mercury register CIOCA LSB value-hybrid,           This parameter is relevant only when a Mercury       -
            impedance, etc.                                    line codec is used.
      4c    Mercury register CIOCB MSB value-transmit gain     This parameter is relevant only when a Mercury       -
                                                               line codec is used.
      4d    Mercury register CIOCB LSB value-BOM control       This parameter is relevant only when a Mercury       -
                                                               line codec is used.
      4e    TAD Mercury register CIOCB MSB value-transmit      This parameter is relevant only when a Mercury
            gain in TAD mode                                   line codec is used.
      4f    FDSP Mercury register CIOCB MSB value-transmit     This parameter is relevant only when a Mercury
            gain in speakerphone mode                          line codec is used.

 */

#define HBASE 0xEE6    /* it is numbered from 1 */

// FIXME: part of byte array starting at 59EFD + 4;

// FIXME: this is actually part of homol[] array
//EXTERN unsigned char byte_59F0B I(0x82);

// Used by modem connection routines.
EXTERN unsigned short x_line_rate, x_line_rate_tx;
EXTERN unsigned short dp_max_line_rate I(0), dp_wV32bisRcvRate I(0);
EXTERN unsigned short wSymbolRate I(0);

EXTERN unsigned int x_modem_ec, x_fax_state;
EXTERN int dp_dialing_status, x_modem_mode; 

EXTERN int dp_timer I(0), dp_ocp_timer I(0);
EXTERN struct lt_timer dp_long_timer;

EXTERN unsigned char x_modem_originate;
EXTERN unsigned char ETC_mode;

EXTERN unsigned short word_59E9E, word_59E9C;

EXTERN unsigned char x_test_mode_on, x_parity_mask, x_dma_xfer;

EXTERN unsigned short x_minute_timer, x_minute_count;

EXTERN unsigned int x_minute_timer_long;

EXTERN unsigned char x_parameter_mode;

EXTERN unsigned short word_59EAB, word_59EAF;

// Other stuff.

EXTERN unsigned char cpcpt_value[0xc00];

EXTERN unsigned char D3Flag, dp_calling_tone_disable;
EXTERN unsigned char dp_failures, dp_blacklist_calls;

EXTERN int x_modem_state, x_dial_residual;

EXTERN short dp_wDspRetrainState;

EXTERN unsigned char V34Mode;

// Set up in dp_board_enable with initial values.
EXTERN unsigned int BaseAddressIndex I(0);
EXTERN unsigned int BaseAddressData I(0);

EXTERN unsigned char BaseValue I(0);

// Bodged country list extracted from countries.h.

#define COUNTRY_AUSTRALIA	1
#define COUNTRY_BELGIUM		2
#define COUNTRY_DENMARK		3
#define COUNTRY_FINLAND		4
#define COUNTRY_FRANCE		5
#define COUNTRY_GERMANY		6
#define COUNTRY_NETHERLANDS	7
#define COUNTRY_ITALY		8
#define COUNTRY_NEW_ZEALAND	9
#define COUNTRY_NORWAY		10
#define COUNTRY_SPAIN		11
#define COUNTRY_SWEDEN		12
#define COUNTRY_SWITZERLAND	13
#define COUNTRY_UNITED_KINGDOM 14
#define COUNTRY_AUSTRIA		15
#define COUNTRY_JAPAN		16
#define COUNTRY_PRC		17
#define COUNTRY_KOREA		18
#define COUNTRY_MALAYSIA	19
#define COUNTRY_SINGAPORE	20
#define COUNTRY_TAIWAN		21
#define COUNTRY_THAILAND	22
#define COUNTRY_INDONESIA	23
#define COUNTRY_PORTUGAL	24
#define COUNTRY_NORTH_AMERICA	25
#define COUNTRY_IRELAND		26
#define COUNTRY_HONG_KONG	27
#define COUNTRY_CANADA		28
#define COUNTRY_MEXICO		29
#define COUNTRY_INDIA		30
#define COUNTRY_VIETNAM		31
#define COUNTRY_PHILIPPINES	32
#define COUNTRY_GREECE		33
#define COUNTRY_HUNGARY		34
#define COUNTRY_TURKEY		35
#define COUNTRY_SOUTH_AFRICA	36
#define COUNTRY_POLAND		37
#define COUNTRY_SLOVENIA	38
#define COUNTRY_SLOVAKIA	39
#define COUNTRY_CZECH_REPUBLIC	40
#define COUNTRY_LUXEMBOURG	41
#define COUNTRY_EUROPE		42
#define COUNTRY_BRAZIL		43
#define COUNTRY_BULGARIA	44
#define COUNTRY_CYPRUS		45
#define COUNTRY_ICELAND		46
#define COUNTRY_RUSSIA		47

#define vendor S[0x75]

// V80 stuff.
EXTERN unsigned char V80_Options[20];
EXTERN unsigned short v80_tx_timer, v80_rx_timer;
EXTERN unsigned char v80_retrain;

#endif
