#!/bin/sh
# Copyright 2000 Angelo Di Filippo
# 
# This script is distributed under GPL license.
#
# This script is done by Mei (m_e_i_69@hotmail.com 
# angelo.difilippo@tiscalinet.it). If you are sure your modem is a
# Lucent isa pnp modem and this script doesn't detect it please send me
# your pnpdump output.

# I must find the isapnp Vendor Id and the serial number of the modem
READPORT=$(pnpdump | grep READPORT)
MODEM=$(pnpdump | \
	grep "{LT Win Modem" | \
	sed 's/ (NAME "//' | \
	sed s/[[][[:graph:][:alnum:][:space:]]*//)

if [ "$MODEM" ]; then
	echo 'ISA PNP Modem Found'
	echo '    Name: '$MODEM
	BOARDS=$(pnpdump | grep -c Board)
	
	QUERY=$(echo $READPORT
		echo '(CSN '$BOARDS')'
		echo '(IDENTIFY *)'
		echo '(VERBOSITY 3)' 
		echo '(CONFIGURE '$MODEM' (LD 0'
		echo '(INT 0 (PEEK))'
		echo '(IO 0 (PEEK))'
		echo '(IO 1 (PEEK))))')

	INT0=$(echo $QUERY | \
		isapnp - | \
		grep '(INT 0)' | \
		sed 's/[[:alnum:][:graph:][:space:]]*,[[:space:]](//' | \
		sed 's/,[[:digit:]]*)//') 

	IO0=$(echo $QUERY | \
		isapnp - | \
		grep '(IO  0)' | \
		sed 's/[[:alnum:][:graph:][:space:]]*is[[:space:]]//' | \
		sed 's/,[[:space:][:graph:][:alnum:]]*//') 

	IO1=$(echo $QUERY | \
		isapnp - | \
		grep '(IO  1)' | \
		sed 's/[[:alnum:][:graph:][:space:]]*is[[:space:]]//' | \
		sed 's/,[[:space:][:graph:][:alnum:]]*//') 

	if [ "$INT0" ]; then
		if [ "$IO0" ]; then
			if [ "$IO1" ]; then
				echo 'IRQ '$INT0 >/etc/ltmodem.conf
				echo 'IO1 '$IO0  >>/etc/ltmodem.conf
				echo 'IO2 '$IO1  >>/etc/ltmodem.conf
			else
				echo IO2 Address Not Found
			fi
		else
			echo IO1 Address Not Found
		fi
	else
		echo Interrupt For The Modem Not Found
	fi
else
	echo ISA PNP Modem Not Found
fi